﻿<AML>
 <Item type="Method" id="43D48FB527D34372B4BF8C8090000798" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			sop_service_pdf
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -Getting Required Information Data.
                -When prompt "Aproved" and Sale Invoice,generate PDF.

            Hooks:
                Called by:	acc_ci_bill_approve
                            acc_sale_bill_approve
                            acc_sale_bill_start_to_gl
            Inputs:
                id,
                invoice_number

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "sop_service_pdf";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _detail_count = 0;
                DateTime dt = DateTime.Now; // Or whatever
                string s_print_date = dt.ToString("yyyyMMddHHmmss");

                var qryItem = myInnovator.newItem();
                string id = this.getProperty("id");
                string invoice_number = this.getProperty("invoice_number");
                string _condition = "";
                string logo_dir = HttpContext.Current.Server.MapPath("Data");
                logo_dir = logo_dir + "\\images\\logo.png";
                iTextSharp.text.Image jpg = iTextSharp.text.Image.GetInstance(logo_dir);
                jpg.ScaleToFit(140f, 120f);

                //var HTMLqry = "";

                /* Get Parameter */
                if (id.Length > 0)
                {
                    _condition = "<id condition='eq'>" + id + "</id>";
                }

                /* AML Query to Pull Out Data  */

                var qry_string = "<Item type='sop_sale_invoice'  action='get' select='id,sop_customer,sop_invoice_date,sop_invoice_remarks,sop_invoice_no,sop_tax_invoice_no,sop_invoice_desc,sop_payment_amount,sop_payment_term,sop_sale_order,erp_company,sop_sold_to,sop_invoice_to,sop_contract_no,sop_sold_to_address,sop_invoice_to_address,sop_po_reference,sop_commercial_no,sop_packing_list_no,pop_total_amount,sop_tax_invoice_line1,sop_invoice_remarks,pop_lumpsum_discount,pop_hide_sub_total,sop_commercial_invoice_line1,sop_bank_account_info,pop_sg_total_amount,pop_sub_amount,pop_sg_sub_amount,pop_sg_gst_amount,pop_gst_amount,acc_tax_type,pop_gst_percent,sop_attention,pop_sg_currency_rate,pop_sg_operator'> "
                + _condition
                + " <acc_project> "
                + " <Item type='hr_project' action='get' select='pr_project_name,pr_project_code'/> "
                + " </acc_project> "
                + " <sop_customer> "
                + " <Item type='customer' action='get' select='name,contact_name,main_phone,main_fax,email'/> "
                + " </sop_customer> "
                + " <sop_ship_to> "
                + "  <Item type='customer' action='get' select='name,contact_name,main_phone,main_fax,email'/> "
                + "  </sop_ship_to> "
                + "  <sop_sold_to> "
                + "  <Item type='customer' action='get' select='name,contact_name,main_phone,main_fax,email'/> "
                + "    </sop_sold_to> "
                + "    <sop_invoice_to> "
                + "    <Item type='customer' action='get' select='name,contact_name,main_phone,main_fax,email'/> "
                + "    </sop_invoice_to> "
                + "    <sop_sale_order> "
                + "            <Item type='sop_sale_order' action='get' select='sop_order_no'/>"
                + "     </sop_sale_order>"
                + "     <erp_company>"
                + " <Item type='erp_company_setup' action='get'  select='erp_com_name,erp_main_email,erp_ph,erp_street,erp_address,erp_fax,erp_registration_number'>"
                + " </Item> "
                + "     </erp_company> "
                + " <Relationships> "
                + "<Item action='get' type='sop_invoice_service_details' select='related_id, stk_item,stk_qty,stk_price,stk_total_amount,stk_description,stk_well'>"
                + " </Item> "
                + " </Relationships> "
                + " </Item>";

                qryItem.loadAML(qry_string);
                var resultItem = qryItem.apply();
                if (resultItem.isError())
                {
                    return myInnovator.newError("Item not found: " + resultItem.getErrorDetail());
                }

                /* End AML Query */
                /* Set FileName */
                string fileName = invoice_number + "_" + s_print_date + "_Tax Invoice(Service).pdf";
                string FullFilePath = Path.Combine(Path.GetTempPath() + fileName);

                /* document opening */
                Document document = new Document(PageSize.A4, 10f, 10f, 50f, 20f);
                PdfWriter writer = PdfWriter.GetInstance(document, new FileStream(FullFilePath, FileMode.Create));
                document.Open();
                /* document opening */

                /* font style */
                Font font8 = FontFactory.GetFont("ARIAL", 8);
                Font font5 = FontFactory.GetFont("ARIAL", 5);
                Font font7 = FontFactory.GetFont("ARIAL", 7);

                Font font12_B = FontFactory.GetFont("ARIAL", 12);
                font12_B.SetStyle(Font.BOLD);
                font12_B.SetColor(0, 0, 0);

                Font font8_B = FontFactory.GetFont("ARIAL", 8);
                font8_B.SetStyle(Font.BOLD);
                font8_B.SetColor(0, 0, 0);

                Font font7_B = FontFactory.GetFont("ARIAL", 7);
                font7_B.SetStyle(Font.BOLD);
                font7_B.SetColor(0, 0, 0);

                Font font5_B = FontFactory.GetFont("ARIAL", 5);
                font5_B.SetStyle(Font.BOLD);
                font5_B.SetColor(0, 0, 0);

                PdfPCell cell = null;
                /* font style */

                /* table width */

                float[] column_oneTalble_widths = new float[] { 6.5f };
                float[] sign_oneTalble_widths = new float[] { 3f };
                /*	float[] widths = new float[] { 0.5f, 1f,0.5f, 3f,0.5f, 0.5f,0.5f };*/
                float[] six_widths = new float[] { 1f, 2.5f, 3.5f, 1f, 2f, 2f };
                float[] two_widths = new float[] { 3.25f, 3.25f };
                //float[] two_widths_bank = new float[] { 3f,3.5f };
                float[] four_widths = new float[] { 1f, 3f, 1f, 1.5f };
                /* table width */
                /*table setting*/
                PdfPTable tableCompany = new PdfPTable(2);
                tableCompany.DefaultCell.Border = Rectangle.NO_BORDER;
                tableCompany.SetWidths(two_widths);

                PdfPTable titleHeader = new PdfPTable(1);
                titleHeader.SetWidths(column_oneTalble_widths);
                titleHeader.DefaultCell.Border = Rectangle.NO_BORDER;
                titleHeader.SpacingAfter = 10f;

                PdfPTable HeaderInfo = new PdfPTable(4);
                HeaderInfo.SetWidths(four_widths);
                HeaderInfo.DefaultCell.Border = Rectangle.NO_BORDER;
                HeaderInfo.SpacingAfter = 10f;

                PdfPTable DetailTable = new PdfPTable(6);
                DetailTable.SetWidths(six_widths);
                DetailTable.DefaultCell.Border = Rectangle.NO_BORDER;
                DetailTable.SpacingAfter = 20f;

                PdfPTable RemarkTable = new PdfPTable(1);
                RemarkTable.SetWidths(column_oneTalble_widths);
                RemarkTable.DefaultCell.Border = Rectangle.NO_BORDER;
                RemarkTable.SpacingAfter = 20f;

                PdfPTable BankTable = new PdfPTable(4);
                BankTable.SetWidths(four_widths);
                BankTable.DefaultCell.Border = Rectangle.NO_BORDER;
                BankTable.SpacingAfter = 80f;

                PdfPTable SignTable = new PdfPTable(2);
                SignTable.SetWidths(two_widths);
                SignTable.DefaultCell.Border = Rectangle.NO_BORDER;

                cell = new PdfPCell();
                /** Get Data From AML */
                var count = resultItem.getItemCount();
                for (int i = 0; i < count; ++i)
                {
                    var itm = resultItem.getItemByIndex(i);
                    var company_name = "";
                    var company_street = "";
                    var company_address = "";
                    var company_ph = "";
                    var company_fax = "";
                    var company_email = "";
                    var company_reg_no = "";
                    var erp_company_id = itm.getProperty("erp_company", "");
                    var erp_company_item = itm.getItemsByXPath("//Item/erp_company/Item[@id='" + erp_company_id + "']");
                    var erp_company_count = erp_company_item.getItemCount();

                    if (erp_company_count > 0)
                    {
                        company_name = erp_company_item.getProperty("erp_com_name");
                        company_street = erp_company_item.getProperty("erp_street");
                        company_address = erp_company_item.getProperty("erp_address");
                        company_ph = erp_company_item.getProperty("erp_ph");
                        company_fax = erp_company_item.getProperty("erp_fax");
                        company_email = erp_company_item.getProperty("erp_main_email");
                        company_reg_no = erp_company_item.getProperty("erp_registration_number");
                    }
                    var invoice_to = "";

                    var sop_invoice_id = itm.getProperty("sop_invoice_to", "");
                    var sop_invoice_item = itm.getItemsByXPath("//Item/sop_invoice_to/Item[@id='" + sop_invoice_id + "']");
                    var sop_invoice_count = sop_invoice_item.getItemCount();

                    if (sop_invoice_count > 0)
                    {
                        invoice_to = sop_invoice_item.getProperty("name");

                    }

                    var invoice_to_address = itm.getProperty("sop_invoice_to_address", "");
                    var attention = itm.getProperty("sop_attention", "");
                    var tax_invoice_no = itm.getProperty("sop_tax_invoice_no", "");

                    var invoice_date = itm.getProperty("sop_invoice_date", "");
                    if (invoice_date != "")
                    {
                        DateTime dt_invoice_date = DateTime.Parse(invoice_date, new CultureInfo("en-CA"));
                        invoice_date = dt_invoice_date.ToString("dd/MM/yyyy");
                    }
                    var payment_term = itm.getProperty("sop_payment_term", "");
                    var contract_no = itm.getProperty("sop_contract_no", "");
                    var customer_po = itm.getProperty("sop_po_reference", "");
                    var packing_list_no = itm.getProperty("sop_packing_list_no", "");
                    var commercial_no = itm.getProperty("sop_commercial_no", "");

                    var so_no = "";
                    var sale_order_id = itm.getProperty("sop_sale_order");

                    var so_item = itm.getItemsByXPath("//Item/sop_sale_order/Item[@id='" + sale_order_id + "']");
                    var so_count = so_item.getItemCount();

                    if (so_count > 0)
                    {
                        so_no = so_item.getProperty("sop_order_no");

                    }

                    /*HTML address*/
                    string htmlcompanyaddress = "<p style='font-weight:bold;font-size:8px' align='left'>" + company_name + "</p>"
                                                            + "<p style='font-weight:bold;font-size:7px' align='left'>" + company_street + "</p>"
                                                            + "<p style='font-weight:bold;font-size:7px' align='left'>" + company_address + "</p>"
                    + "<p style='font-weight:bold;font-size:7px' align='left'>Tel:" + company_ph + " Fax:" + company_fax + " Email:" + company_email + "</p>"
                                                            + "<p style='font-weight:bold;font-size:7px' align='left'>" + company_fax + "</p>"
                                                            + "<p style='font-weight:bold;font-size:7px' align='left'>" + company_reg_no + "</p>";

                    cell = new PdfPCell(jpg);
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    cell.Border = Rectangle.RIGHT_BORDER | Rectangle.BOTTOM_BORDER;
                    cell.PaddingRight = 4;
                    cell.PaddingBottom = 4;
                    cell.BorderWidthRight = 2f;
                    cell.BorderWidthBottom = 2f;
                    tableCompany.AddCell(cell);

                    using (StringReader sr = new StringReader(htmlcompanyaddress))
                    {
                        List<IElement> elements = iTextSharp.text.html.simpleparser.HTMLWorker.ParseToList(sr, null);
                        foreach (IElement e in elements)
                        {
                            //Add those elements to the paragraph
                            cell.AddElement(e);
                        }
                    }

                    cell.HorizontalAlignment = Element.ALIGN_LEFT;
                    cell.Border = Rectangle.LEFT_BORDER | Rectangle.BOTTOM_BORDER;
                    cell.PaddingBottom = 4;
                    cell.PaddingLeft = 4;
                    cell.BorderWidthBottom = 2f;
                    tableCompany.AddCell(cell);

                    /*title*/
                    cell = new PdfPCell(new Phrase(new Chunk("Tax INVOICE", font12_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    cell.Border = Rectangle.NO_BORDER;
                    titleHeader.AddCell(cell);

                    /*Header info*/
                    cell = new PdfPCell(new Phrase(new Chunk("Invoice To:", font7_B)));
                    cell.VerticalAlignment = Element.ALIGN_CENTER;
                    cell.Border = Rectangle.NO_BORDER;
                    cell.Rowspan = 8;
                    HeaderInfo.AddCell(cell);
                    
                    cell = new PdfPCell(new Phrase(new Chunk(invoice_to + "\n\n" + invoice_to_address + "\n\n\n\nAttention:" + attention, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    cell.Rowspan = 8;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("Invoice  No", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(tax_invoice_no, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    /*Header info*/

                    cell = new PdfPCell(new Phrase(new Chunk("Date:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(invoice_date, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("Payment Term", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(payment_term, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("Contract No:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(contract_no, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("Customer PO:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(customer_po, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("Packing List No:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk(packing_list_no, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("Commercial NO:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(commercial_no, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("SO NO:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(so_no, font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    HeaderInfo.AddCell(cell);

                    /*Detail Grid*/
                    var _sg_sub_total = itm.getProperty("pop_sg_sub_amount");
                    var _usd_sub_amount = itm.getProperty("pop_sub_amount");
                    var _sg_gst_amount = itm.getProperty("pop_sg_gst_amount");
                    var _tax_type = itm.getProperty("acc_tax_type");
                    if (_tax_type == "SR")
                    {
                        _tax_type = "Std Rate";
                    }
                    else if (_tax_type == "ZR")
                    {
                        _tax_type = "Zero Rate";
                    }
                    else if (_tax_type == "OSS")
                    {
                        _tax_type = "Out of Scope";
                    }

                    //set title for detail table
                    cell = new PdfPCell(new Phrase(new Chunk("ITEM", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("PART NO", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    DetailTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("DESCRITPION", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("QTY", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    DetailTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("UNIT PRICE", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    DetailTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Total Price", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_CENTER;
                    DetailTable.AddCell(cell);

                    var well = "";
                    decimal well_sub_total = 0;
                    decimal usd_grand_total = 0;
                    var sale_invoice_detail = itm.getItemsByXPath("//Item/Relationships/Item['sop_invoice_service_details']");
                    _detail_count = sale_invoice_detail.getItemCount();

                    for (int j = 0; j < _detail_count; ++j)
                    {

                        Item sale_invoice_detail_data = sale_invoice_detail.getItemByIndex(j);
                        var _detail_id = sale_invoice_detail_data.getProperty("id");
                        var _item = sale_invoice_detail_data.getProperty("stk_item");
                        var part_no = "-";
                        var description = sale_invoice_detail_data.getProperty("stk_description");
                        var qty = sale_invoice_detail_data.getProperty("stk_qty");
                        var price = sale_invoice_detail_data.getProperty("stk_price");
                        var line_total_amount = sale_invoice_detail_data.getProperty("stk_total_amount");
                        decimal decimal_line_total_amount = Convert.ToDecimal(line_total_amount);

                        if (well == sale_invoice_detail_data.getProperty("stk_well"))
                        {
                            well_sub_total += decimal_line_total_amount;
                        }
                        else
                        {
                            if (j != 0)
                            {
                                cell = new PdfPCell(new Phrase(new Chunk("Sub Total For " + well.ToString(), font8_B)));
                                cell.Colspan = 5;
                                cell.HorizontalAlignment = Element.ALIGN_CENTER;
                                DetailTable.AddCell(cell);

                                cell = new PdfPCell(new Phrase(new Chunk("$  " + Convert.ToString(well_sub_total), font7)));
                                cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                                DetailTable.AddCell(cell);

                                well_sub_total = 0;
                            }

                            cell = new PdfPCell(new Phrase(new Chunk(sale_invoice_detail_data.getProperty("stk_well").ToString(), font8_B)));
                            cell.Colspan = 6;
                            cell.HorizontalAlignment = Element.ALIGN_CENTER;
                            DetailTable.AddCell(cell);
                            well = sale_invoice_detail_data.getProperty("stk_well");
                            well_sub_total += decimal_line_total_amount;
                        }
                        cell = new PdfPCell(new Phrase(new Chunk(_item.ToString(), font7)));
                        DetailTable.AddCell(cell);

                        cell = new PdfPCell(new Phrase(new Chunk(part_no, font7)));
                        DetailTable.AddCell(cell);


                        cell = new PdfPCell(new Phrase(new Chunk(description, font7)));
                        DetailTable.AddCell(cell);


                        cell = new PdfPCell(new Phrase(new Chunk(qty, font7)));
                        cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                        DetailTable.AddCell(cell);
                        cell = new PdfPCell(new Phrase(new Chunk("$  " + price, font7)));
                        cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                        DetailTable.AddCell(cell);
                        cell = new PdfPCell(new Phrase(new Chunk("$  " + line_total_amount, font7)));
                        cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                        DetailTable.AddCell(cell);

                        if (j == _detail_count - 1)
                        {
                            cell = new PdfPCell(new Phrase(new Chunk("Sub Total For " + well.ToString(), font8_B)));
                            cell.Colspan = 5;
                            cell.HorizontalAlignment = Element.ALIGN_CENTER;
                            DetailTable.AddCell(cell);

                            cell = new PdfPCell(new Phrase(new Chunk("$  " + Convert.ToString(well_sub_total), font7)));
                            cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                            DetailTable.AddCell(cell);

                            well_sub_total = 0;
                        }
                        usd_grand_total += decimal_line_total_amount;

                    }
                    //Calculation
                    var sg_currency_rate = itm.getProperty("pop_sg_currency_rate");
                    decimal decimal_sg_currency_rate = Convert.ToDecimal(sg_currency_rate);
                    var _operator = itm.getProperty("pop_sg_operator");
                    var gst_percent = itm.getProperty("pop_gst_percent");
                    decimal decimal_gst_percent = Convert.ToDecimal(gst_percent);
                    decimal sg_sub_amount = 0;
                    decimal sg_gst_amount = 0;
                    decimal sg_total = 0;
                    decimal usd_gst_amount = 0;
                    decimal usd_total = 0;
                    usd_gst_amount = usd_grand_total * decimal_gst_percent / 100;
                    usd_total = usd_grand_total + usd_gst_amount;
                    if (_operator == "*")
                    {
                        sg_sub_amount = usd_grand_total * decimal_sg_currency_rate;
                        sg_gst_amount = usd_gst_amount * decimal_sg_currency_rate;
                        sg_total = usd_total * decimal_sg_currency_rate;
                    }
                    else
                    {
                        sg_sub_amount = usd_grand_total / decimal_sg_currency_rate;
                        sg_gst_amount = usd_gst_amount / decimal_sg_currency_rate;
                        sg_total = usd_total / decimal_sg_currency_rate;
                    }

                    /*1 ROW*/
                    cell = new PdfPCell(new Phrase(new Chunk("SGD", font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    cell.Colspan = 3;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk(Convert.ToString(Math.Round(sg_sub_amount, 2)), font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("SUB TOTAL", font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("USD   " + Convert.ToString(Math.Round(usd_grand_total, 2)), font7)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    /*2 ROW*/
                    cell = new PdfPCell(new Phrase(new Chunk("SGD", font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    cell.Colspan = 3;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk(Convert.ToString(Math.Round(sg_gst_amount, 2)), font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("GST@" + _tax_type + gst_percent + "%", font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("USD   " + Convert.ToString(Math.Round(usd_gst_amount, 2)), font7)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    /*3 ROW*/
                    cell = new PdfPCell(new Phrase(new Chunk("SGD", font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    cell.Colspan = 3;
                    DetailTable.AddCell(cell);


                    cell = new PdfPCell(new Phrase(new Chunk(Convert.ToString(Math.Round(sg_total, 2)), font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("GRAND TOTAL", font7_B)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);

                    cell = new PdfPCell(new Phrase(new Chunk("USD   " + Convert.ToString(Math.Round(usd_total, 2)), font7)));
                    cell.HorizontalAlignment = Element.ALIGN_RIGHT;
                    DetailTable.AddCell(cell);


                    /*Remark*/
                    var _invoice_remarks = itm.getProperty("sop_invoice_remarks");

                    cell = new PdfPCell(new Phrase(new Chunk("REMARKS", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    RemarkTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(_invoice_remarks, font7)));
                    cell.Border = Rectangle.NO_BORDER;
                    RemarkTable.AddCell(cell);

                    /*Bank Table*/
                    cell = new PdfPCell(new Phrase(new Chunk("Please remit payment to:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    cell.Colspan = 4;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Account Details:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    cell.Colspan = 4;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Company Name:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(company_name, font7_B)));
                    cell.Colspan = 3;
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Bank Name:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("UNITED OVERSEAS BANK LTD/7375", font7_B)));
                    cell.Colspan = 3;
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Bank Address:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("325, BOON LAY PLACE SINGAPORE 649886 BOON LAY BRANCH /035", font7_B)));
                    cell.Colspan = 3;
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Bank AC number:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("363-900-654-7", font7_B)));
                    cell.Colspan = 3;
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("Bank swift code:", font7_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("UOVBSGSG", font7_B)));
                    cell.Colspan = 3;
                    cell.Border = Rectangle.NO_BORDER;
                    BankTable.AddCell(cell);


                    cell = new PdfPCell(new Phrase(new Chunk("AUTHORISED SIGNATORY", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_LEFT;
                    cell.Border = Rectangle.TOP_BORDER;
                    SignTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("", font8_B)));
                    cell.Border = Rectangle.NO_BORDER;
                    //	cell.Border = Rectangle.TOP_BORDER;
                    SignTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk(company_name, font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_LEFT;
                    cell.Border = Rectangle.NO_BORDER;
                    SignTable.AddCell(cell);
                    cell = new PdfPCell(new Phrase(new Chunk("", font8_B)));
                    cell.HorizontalAlignment = Element.ALIGN_LEFT;
                    cell.Border = Rectangle.NO_BORDER;
                    SignTable.AddCell(cell);

                }
                document.Add(tableCompany);
                document.Add(titleHeader);
                document.Add(HeaderInfo);
                document.Add(DetailTable);
                document.Add(RemarkTable);
                document.Add(BankTable);
                document.Add(SignTable);

                document.Close();

                /* Check In and  File Add */
                if (_detail_count > 0)
                {
                    string fileAddID = string.Empty;
                    if (FullFilePath != string.Empty)
                    {
                        Item fileAdd = myInnovator.newItem("File", "add");
                        fileAdd.setProperty("filename", fileName);
                        fileAdd.attachPhysicalFile(FullFilePath);
                        fileAdd = fileAdd.apply();
                        fileAddID = fileAdd.getID();
                        if (fileAdd.isError())
                        {
                            throw new Exception(string.Format("Failed to check-in file '{0}': {1}", FullFilePath));
                        }
                        //save merge file in Purchase Order 

                        Item add_file_sale_invoice = myInnovator.newItem("sop_sale_invoice_file", "add");
                        add_file_sale_invoice.setProperty("source_id", id);
                        add_file_sale_invoice.setProperty("related_id", fileAddID);
                        add_file_sale_invoice.apply();
                        if (add_file_sale_invoice.isError())
                        {
                            throw new Exception(string.Format("fail to attach"));
                        }
                        Item Update_Button_Status = myInnovator.applySQL("Update innovator.[sop_sale_invoice] set sop_tax_button_status=1 where id='" + id + "' ");
                        if (Update_Button_Status.isError())
                        {
                            throw new Exception(string.Format("fail to update button status"));
                        }
                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>sop_service_pdf</name>
 </Item>
</AML>